EQW = function(
validities =  c(.8,.7,.6,.55), 
cuePattern = cbind(c(1,1,1,-1),c(-1,-1,-1,1))
){

########################
########################
########################
#### recode validities and patterns if val < .5

recodeVal = which(round(validities, 6) < .5)

if (length(recodeVal) > 0){

validities[recodeVal] = 1 - validities[recodeVal]
cuePattern[recodeVal,] = cuePattern[recodeVal,] * -1
}

########################
########################
########################

EQWsumDiff = sum(cuePattern[,1]) - sum(cuePattern[,2])

choiceEQW = ifelse(round(EQWsumDiff,6) > 0, 1 , 2)
choiceEQW = ifelse(round(EQWsumDiff,6) == 0, 1/2, choiceEQW)
choiceEQW = ifelse(round(choiceEQW,6) == 2, 0, choiceEQW)

timeEQW = (2 * NROW(validities)) + (2 * NROW(validities) - 2) + 2 

confEQW = abs(EQWsumDiff) 

EQWpredTotal = c(choiceEQW,timeEQW,confEQW)
names(EQWpredTotal) = c("choice","time","confidence") 

return(EQWpredTotal)
}

###

library(compiler)
EQW = cmpfun(EQW)