### PCS version 2 05.06.2012; jekel@coll.mpg.de

PCSv2 = function(
activ = c(1,0,0,0,0),
weightsNet = rbind(
c(0,.4,.3,0,0),
c(.4,0,0,.01,-.01),
c(.3,0,0,-.01,.01),
c(0,.01,-.01,0,-.2),
c(0,-.01,.01,-.2,0)),
flo = -1, 
ceil = 1, 
decay = .1, 
stability = 10^6, 
maxiter = 1000
){

# define variables

ener = rep(0, maxiter)
iter = 1

# activation matrix at t = 1

matWeightedAct = activ * weightsNet

while (iter != maxiter){

# input for each node in the net

input = colSums(matWeightedAct)

# activation for each node for t + 1

activ =  (1-decay) * activ + input * 
ifelse(round(input, 6) < 0, activ - flo, ceil - activ)

# set activation of source node to 1

activ[1] = 1

# activation matrix at t + 1

matWeightedAct = activ * weightsNet

# energy at t + 1

ener[iter] = -sum(t(matWeightedAct) * activ)

# evaluate stopping criterion at t + 1

if (iter > 10){

if(sum(floor(stability * (ener[(iter  - 10) : (iter-1)])) - 
floor(stability * (ener[iter]))  == 0) == 10){
iter = iter + 1
break()
}}

iter = iter + 1
# print(c(iter, ener[iter-1], activ))
}

# prompt output of function

return(c(iter, ener[iter-1], activ))
}

# compile function (for faster execution)

library(compiler)
PCSv2 = cmpfun(PCSv2)
